##########################################################
##                                                      ##
## INSTALL PROCEDURE FOR CMF/PLONE TYPES                ##
##                                                      ##
## This can be shared across IW products ! :-)          ##
## Just edit the tagged lines (## EDIT)                 ##
##                                                      ##
##########################################################


# EDIT FROM HERE...
from Products.PloneChat import install_globals, PloneChat
from Products.PloneChat.global_symbols import *
# ...TO HERE
from Products.PloneChat.Installation import Installation
from Products.CMFCore.utils import getToolByName

import Globals

import string

import os, glob, re

# EDIT FROM HERE...
fti_list = (
    PloneChat.factory_type_information,
    )
fti_list2 = (
    PloneChat.factory_type_information2,
    )
types_list = (
    "PloneChat",
    )
skin_name = "PloneChat"
perms_list = (
    PloneChat_addPermission,
    PloneChat_editPermission,
    PloneChat_unrestrictedChatPermission,
    PloneChat_moderatePermission,
    PloneChat_restrictedChatPermission,
    )
i18n_name = "PloneChat"
# ...TO HERE

def setPermissions(self, perms_list, out):
        """
        setPermissions(self) => Set standard permissions / roles
        """
        # As a default behavior, newly-created permissions are granted to owner and manager.
        # To change this, just comment this code and grab back the code commented below to
        # make it suit your needs.
        for perm in perms_list:
            self.manage_permission(
                perm,
                ('Manager', 'Owner'),
                acquire = 1
                )
        # Set special permissions
        self.manage_permission(   
            PloneChat_restrictedChatPermission,   
            ('Member', 'Manager', 'Owner', ),   
            acquire = 1,   
        )   
        self.manage_permission(   
            PloneChat_moderatePermission,   
            ('Reviewer', 'Manager', ),   
            acquire = 1,   
        )
        out.write("Reseted default permissions\n")
        
def install(self):
    installation=Installation(self)
    setPermissions(self, perms_list, installation.out)
    installation.setupTypesandSkins(fti_list, skin_name, install_globals, fti_list2 = fti_list2)
    domain=string.lower(i18n_name)
    poPrefix='%s_' % (string.lower(i18n_name), )
    if not installation.isPlone2():
        for ctype in types_list:
            validation = [
                  ('%s_editForm' % (ctype), 'validate_id,validate_%s_edit' % ctype, ),
                  ]
            installation.addFormValidators(validation)
            lowertype=ctype.lower()
            transitions = [
                  ('%s.%s_editForm.success' % (lowertype, ctype ), 'script:%s_edit' % (ctype), ),
                  ('%s.%s_editForm.failure' % (lowertype, ctype ), '%s_editForm' % (ctype), ),
                  ('%s.%s_edit.success' % (lowertype, ctype ), 'action:view', ),
                  ('%s.%s_edit.failure' % (lowertype, ctype ), 'action:edit', ),
                  ]
            installation.addNavigationTransitions(transitions)
    #installation.installMessageCatalog(self, install_globals, domain, poPrefix)

    PROJECTNAME="PloneChat"
    provider = getToolByName(self, 'portal_selenium', None)
    if provider:
        # Functional Tests
        action = {'id':PROJECTNAME.lower(),
                  'name':PROJECTNAME,
                  'action':'string:here/get_%s_ftests'%PROJECTNAME.lower(),
                  'condition': '',
                  'permission': 'View',
                  'category':'ftests',
                  'visible': 1}
        provider.addAction(**action)

    typesTool = getToolByName(self, 'portal_types')
    # Set the human readable title explicitly
    t = getattr(typesTool, 'PloneChat', None)
    if t:
        t.title = 'Chat'

    return installation.report()

