## Script (Python) "PloneChat_edit"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=id='', title=None, description=None, chat_date=None, moderation=0, refresh_rate=10, time_format=''
##title=Edit a PloneChat
##

# if there is no id specified, keep the current one
if not id:
    id = context.getId()

from DateTime import DateTime

# need to parse date string *before* passing to PloneChat.manage_editPloneChat...
dt_date = DateTime(chat_date)

new_context = context.portal_factory.doCreate(context, id)

# Custom editing method (called only for specific attributes)
new_context.manage_editPloneChat(moderation = moderation,
                                 refresh_rate = int(refresh_rate),
                                 chatDay = dt_date.year(),
                                 chatMonth = dt_date.month(),
                                 chatYear = dt_date.day(),
                                 time_format = time_format
                 )

# Generic editing method (ie. edits id + Metadata)
new_context.plone_utils.contentEdit(new_context,
                                    id = id,
                                    title = title,
                                    description = description)

message=context.REQUEST.get('portal_status_message',
                    'PloneChat changes saved.')
return ('success', new_context, {'portal_status_message':message})
